package net.corda.sgx.attestation.entities

import net.corda.sgx.enclave.ECKey

/**
 * Remote attestation challenge from service provider.
 */
class Challenge(

        /**
         * A one-time number generated by the service provider and used
         * throughout the attestation to protect against replay attacks.
         */
        val nonce: String,

        /**
         * The long-term identity key of the challenger.
         */
        val publicKey: ECKey

)
